-- Teleport Stone v2.0
-- By _Q_
-- Graphics by Raccoon Superhero
-- Character quotes by Silentdarkness1
-- Mark location with telepstone, and recall to that location at later time. 
-- Marked location shows on minimap.
-- Teleporting will cost you 40 sanity or 30 health and 20% of the stone.
-- Mark and reset actions don't have any cost. 
-- You can reset marked location by holding Ctrl key and right clicking over telestone.
-- Stone will recharge by 20% every fullmoon night.
-- To craft the stone you need 15x nightmare fuel, purple gem and shadow manipulator.
-- 19.03.2014 
-- Thanks to Heavenfall, zeidrich,  no_signal for help with the code.

Ingredient = GLOBAL.Ingredient
RECIPETABS = GLOBAL.RECIPETABS
STRINGS = GLOBAL.STRINGS
ACTIONS = GLOBAL.ACTIONS
TECH = GLOBAL.TECH

TUNING.BLACKSTONE_USES = 5
STRINGS.NAMES.BLACKSTONE = "Telestone"
STRINGS.RECIPE_DESC.BLACKSTONE = "Live to starve another day."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.BLACKSTONE = 
{ 
GENERIC = "There's a mystery inside this stone.",
MOONPOWER = "I think it needs to charge. Maybe the moon has the answer.",
MARKED = "Whatever it does, it’s ready."
}

STRINGS.CHARACTERS.WILLOW.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "I see fire in this stone!",
MOONPOWER = "It’s useless now. But it’d look great in the moonlight.",
MARKED = "I don’t know how it works, but it does."
}

STRINGS.CHARACTERS.WENDY.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "Another device to help delay the inevitable.",
MOONPOWER = "It is exhausted, but it’s power grows by the light of the moon.",
MARKED = "It is ready, but am I?"
}

STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "This rock scares Wolfgang.",
MOONPOWER = "Scary rock is sleepy.",
MARKED = "Scary stone is not so scary now."
}

STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "Not sure what this does.\n But, nothing ventured, nothing gained!",
MOONPOWER = "If my research is correct, the lunar cycle can invigorate this stone.",
MARKED = "Caution is always the best option."
}

STRINGS.CHARACTERS.WAXWELL.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "The perfect relic for a quick getaway.",
MOONPOWER = "It draws it’s power from the moonlight.",
MARKED = "Now if only I could use this to escape Them."
}

STRINGS.CHARACTERS.WOODIE.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "Smooth like a skippin' stone, eh?",
MOONPOWER = "Seems like it’s all spent up, eh?",
MARKED = "I’m not sure if I want to keep holding onto this thing."
}

STRINGS.CHARACTERS.WX78.DESCRIBE.BLACKSTONE =
{ 
GENERIC = "EMERGENCY RELOCATION STONE.",
MOONPOWER = "BATTERY DRAINED. INITIATE CHARGE SEQUENCE?",
MARKED = "INITIALIZE?"
}

STRINGS.ACTIONS.MARK = "Create Telestone Mark"      
STRINGS.ACTIONS.RECALL = "Telelocate"
STRINGS.ACTIONS.RESET = "Destroy Telestone Mark"

PrefabFiles = 
{
	"blackstone",
	"mark",
}

Assets = 
{
	Asset("ATLAS", "images/inventoryimages/blackstone.xml"),
	Asset("ATLAS", "images/mark.xml"),
}

AddMinimapAtlas("images/mark.xml")

local blackstone = GLOBAL.Recipe("blackstone", {Ingredient("nightmarefuel", 15), Ingredient("purplegem", 1)}, RECIPETABS.MAGIC,  TECH.MAGIC_THREE)
blackstone.atlas = "images/inventoryimages/blackstone.xml"

function StoneSimPostInit()

ACTIONS.RESET = GLOBAL.Action()
ACTIONS.RESET.fn = function(act)
 local tar = act.target or act.invobject
  if tar and tar.components.telestone and tar.components.telestone:IsMarked() or tar.components.telestone:IsMarkedCave() then
            tar.components.telestone:Reset(tar)
        return true
    end
end

ACTIONS.MARK = GLOBAL.Action()
ACTIONS.MARK.fn = function(act)
 local tar = act.target or act.invobject
  if tar and tar.components.telestone and not tar.components.telestone:IsMarked() or not tar.components.telestone:IsMarkedCave() then
        tar.components.telestone:Mark(tar)
        return true
    end
end

ACTIONS.RECALL = GLOBAL.Action()
ACTIONS.RECALL.fn = function(act)
  local tar = act.target or act.invobject
   if tar and tar.components.telestone and tar.components.telestone:IsMarked() or tar.components.telestone:IsMarkedCave() then
             tar.components.telestone:Recall(act.doer)
         return true
     end
end
 
for k,v in pairs(ACTIONS) do
	if (k == "MARK" or k == "RECALL" or k == "RESET") then
    		v.str = STRINGS.ACTIONS[k] or "ACTION"
   		 v.id = k
	 end
end

local function addActionHandler(SGname, action, state, condition)
	actionHandler = GLOBAL.ActionHandler(action, state, condition)
	for k,v in pairs(GLOBAL.SGManager.instances) do	
		if(k.sg.name == SGname) then
			k.sg.actionhandlers[action] = actionHandler
			break
		end
	end
end

local function addState(SGname, state)
	 for k,v in pairs(GLOBAL.SGManager.instances) do	
		if(k.sg.name == SGname) then
			k.sg.states[state.name] =  state
			break
		end
	 end
end

addActionHandler("wilson", GLOBAL.ACTIONS.RESET, "reset")

local reset = GLOBAL.State{
        name = "reset",
        tags = {"doing"},
        
        onenter = function(inst, timeout)
            
            inst.sg:SetTimeout(timeout or 1)
            inst.components.locomotor:Stop()
            inst.SoundEmitter:PlaySound("dontstarve/rain/thunder_close", "make")
            
            inst.AnimState:PlayAnimation("build_pre")
            inst.AnimState:PushAnimation("build_loop", true)
        end,
        
        ontimeout= function(inst)
            inst.AnimState:PlayAnimation("build_pst")
            inst.sg:GoToState("idle", false)
            inst:PerformBufferedAction()
        
        end,
        
        onexit= function(inst)
            inst.SoundEmitter:KillSound("make")
        end, 
    }

    addState("wilson", reset)	

addActionHandler("wilson", GLOBAL.ACTIONS.MARK, "mark")

local mark = GLOBAL.State{
        name = "mark",
        tags = {"doing"},
        
        onenter = function(inst, timeout)
            
            inst.sg:SetTimeout(timeout or 1)
            inst.components.locomotor:Stop()
            inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod", "make")
            
            inst.AnimState:PlayAnimation("build_pre")
            inst.AnimState:PushAnimation("build_loop", true)
        end,
        
        ontimeout= function(inst)
            inst.AnimState:PlayAnimation("build_pst")
            inst.sg:GoToState("idle", false)
            inst:PerformBufferedAction()
        
        end,
        
        onexit= function(inst)
            inst.SoundEmitter:KillSound("make")
        end, 
    }

    addState("wilson", mark)	

addActionHandler("wilson", GLOBAL.ACTIONS.RECALL, "recall")

local recall = GLOBAL.State{
        name = "recall",
        tags = {"doing"},
        
        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("teleport")

			inst:DoTaskInTime(4.7, function(inst) inst.SoundEmitter:PlaySound("dontstarve/common/teleportato/teleportato_pulled") end )
        end,
        
		timeline =
        {
			GLOBAL.TimeEvent(19*GLOBAL.FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/common/teleportato/teleportato_under") end),
		},

        events=
        {
            GLOBAL.EventHandler("animover", function(inst)
				inst:PerformBufferedAction()
				inst.sg:GoToState("idle") 
			end ),
        },
    }

	addState("wilson", recall)
	
end

AddSimPostInit(StoneSimPostInit)

function FiniteUsesPostInit(inst)

	function inst:IsEmpty()
		return self.current <= 0
	end
	
	function inst:AddUse(num)
		inst.current = inst.current + num
		inst.inst:PushEvent("percentusedchange", {percent = inst:GetPercent()}) 
	end
	
end

AddComponentPostInit("finiteuses", FiniteUsesPostInit)

AddPrefabPostInit("world", function(inst)

	GLOBAL.assert( GLOBAL.GetPlayer() == nil )

	local player_prefab = GLOBAL.SaveGameIndex:GetSlotCharacter()

	GLOBAL.TheSim:LoadPrefabs {player_prefab}

	local oldfn = GLOBAL.Prefabs[player_prefab].fn
	GLOBAL.Prefabs[player_prefab].fn = function()
		local inst = oldfn()

		inst:AddComponent("telestonelimiter")
		
		return inst
	end
end)